﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace YieldReturnAndUsing
{
    internal sealed class CorrectEnumerable : IEnumerable<Int32>
    {
        public CorrectEnumerable ()
        {
            Tracer.Trace(TraceState.Entering, "CorrectEnumerable.ctor");
            Tracer.Trace(TraceState.Leaving, "CorrectEnumerable.ctor");
        }

        #region IEnumerable<Int32> Members

        IEnumerator<Int32> IEnumerable<Int32>.GetEnumerator()
        {
            Tracer.Trace(TraceState.Entering, "CorrectEnumerable.IEnumerable<Int32>.GetEnumerator");

            IEnumerator<Int32> enumerator = new CorrectEnumerator();

            Tracer.Trace(TraceState.Leaving, "CorrectEnumerable.IEnumerable<Int32>.GetEnumerator");

            return (enumerator);
        }

        #endregion

        #region IEnumerable Members

        IEnumerator IEnumerable.GetEnumerator()
        {
            Tracer.Trace(TraceState.Entering, "CorrectEnumerable.IEnumerable.GetEnumerator");

            IEnumerable<Int32> enumerable = (IEnumerable<Int32>)this;

            IEnumerator<Int32> enumerator = enumerable.GetEnumerator();

            Tracer.Trace(TraceState.Leaving, "CorrectEnumerable.IEnumerable.GetEnumerator");

            return (enumerator);
        }

        #endregion
    }
}