﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace YieldReturnAndUsing
{
    internal sealed class CorrectEnumerator : IEnumerator<Int32>
    {
        private Int32 m_CurrentIndex;

        private ReadOnlyCollection<INumber> m_TheList;

        private IDisposableNumbersCollection m_Collection;

        public CorrectEnumerator()
        {
            Tracer.Trace(TraceState.Entering, "CorrectEnumerator.ctor");
            
            m_Collection = new DisposableNumbersCollection();
            m_TheList = m_Collection.TheList;
            m_CurrentIndex = -1;

            Tracer.Trace(TraceState.Leaving, "CorrectEnumerator.ctor");
        }

        #region IEnumerator<Int32> Members

        Int32 IEnumerator<Int32>.Current
        {
            get
            {
                Tracer.Trace(TraceState.Entering, "CorrectEnumerator.IEnumerator<Int32>.Current.get");

                Int32 theNumber = m_TheList[m_CurrentIndex].TheNumber;

                Tracer.Trace(TraceState.Leaving, "CorrectEnumerator.IEnumerator<Int32>.Current.get");

                return (theNumber);
            }
        }

        #endregion

        #region IDisposable Members

        void IDisposable.Dispose()
        {
            Tracer.Trace(TraceState.Entering, "CorrectEnumerator.Dispose");

            m_TheList = null;

            m_Collection.Dispose();

            m_Collection = null;

            Tracer.Trace(TraceState.Leaving, "CorrectEnumerator.Dispose");
        }

        #endregion

        #region IEnumerator Members

        Object IEnumerator.Current
        {
            get
            {
                Tracer.Trace(TraceState.Entering, "CorrectEnumerator.IEnumerator.Current.get");

                IEnumerator<Int32> enumerator = (IEnumerator<Int32>)this;

                Int32 current = enumerator.Current;

                Tracer.Trace(TraceState.Leaving, "CorrectEnumerator.IEnumerator.Current.get");

                return (current);
            }
        }

        Boolean IEnumerator.MoveNext()
        {
            Tracer.Trace(TraceState.Entering, "CorrectEnumerator.MoveNext");

            m_CurrentIndex++;

            Boolean hasNext = (m_CurrentIndex < m_TheList.Count);

            Tracer.Trace(TraceState.Leaving, "CorrectEnumerator.MoveNext");

            return (hasNext);
        }

        void IEnumerator.Reset()
        {
            Tracer.Trace(TraceState.Entering, "CorrectEnumerator.Reset");

            m_CurrentIndex = -1;

            Tracer.Trace(TraceState.Leaving, "CorrectEnumerator.Reset");
        }

        #endregion
    }
}