﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace YieldReturnAndUsing
{
    internal static class EnumerableTester
    {
        internal static IEnumerable<Int32> GetNumbersCorrectly()
        {
            Tracer.Trace(TraceState.Entering, "EnumerableTester.GetNumbersCorrectly");

            IEnumerable<Int32> enumerable = new CorrectEnumerable();

            Tracer.Trace(TraceState.Leaving, "EnumerableTester.GetNumbersCorrectly");

            return (enumerable);
        }

        internal static IEnumerable<Int32> GetNumbersWrongly()
        {
            Tracer.Trace(TraceState.Entering, "EnumerableTester.GetNumbersWrongly");

            using (IDisposableNumbersCollection collection = new DisposableNumbersCollection())
            {
                IEnumerable<Int32> enumerable = IterateOverNumbers(collection);

                Tracer.Trace(TraceState.Leaving, "EnumerableTester.GetNumbersWrongly");

                return (enumerable);
            }
        }

        internal static IEnumerable<Int32> IterateOverNumbers(IDisposableNumbersCollection collection)
        {
            Tracer.Trace(TraceState.Entering, "EnumerableTester.IterateOverNumbers");

            IEnumerable<Int32> enumerable = new WrongEnumerable(collection);

            Tracer.Trace(TraceState.Leaving, "EnumerableTester.IterateOverNumbers");

            return (enumerable);
        }
    }
}