﻿using System;
using System.Diagnostics;

namespace YieldReturnAndUsing
{
    internal interface INumber
    {
        Int32 TheNumber { get; }
    }

    [DebuggerStepThrough]
    internal sealed class Number : INumber
    {
        private readonly Int32 m_TheNumber;

        public Number(Int32 theNumber)
        {
            Tracer.Trace(TraceState.Entering, "Number.ctor");
            
            m_TheNumber = theNumber;

            Tracer.Trace(TraceState.Leaving, "Number.ctor");
        }

        #region INumber Members

        Int32 INumber.TheNumber
        {
            get
            {
                Tracer.Trace(TraceState.Entering, "Number.TheNumber.get");
                Tracer.Trace(TraceState.Leaving, "Number.TheNumber.get");

                return (m_TheNumber);
            }
        }

        #endregion
    }
}