﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace YieldReturnAndUsing
{
    public static class Program
    {
        public static void Main()
        {
            Tracer.Trace(TraceState.Entering, "Program.Main");

            Fail();

            Tracer.Output("".PadRight(80, '-'));

            Success1();

            Tracer.Output("".PadRight(80, '-'));

            Success2();

            Tracer.Output("".PadRight(80, '-'));

            Success3();

            Tracer.Trace(TraceState.Leaving, "Program.Main");

            Console.ReadLine();
        }

        private static void Success3()
        {
            Tracer.Trace(TraceState.Entering, "Program.Success3");

            IEnumerable<Int32> theNumbers = EnumerableTester.GetNumbersCorrectly();

            Int32 count = 0;

            using (IEnumerator<Int32> enumerator = theNumbers.GetEnumerator())
            {
                Boolean hasNext = enumerator.MoveNext();

                while (hasNext)
                {
                    count++;

                    Int32 theNumber = enumerator.Current;

                    Tracer.Output(theNumber);

                    if (count == 3)
                    {
                        break;
                    }

                    hasNext = enumerator.MoveNext();
                }
            }

            Tracer.Trace(TraceState.Leaving, "Program.Success3");
        }

        private static void Success2()
        {
            Tracer.Trace(TraceState.Entering, "Program.Success2");

            IEnumerable<Int32> theNumbers = EnumerableTester.GetNumbersCorrectly();

            Int32 count = 0;

            foreach (Int32 theNumber in theNumbers)
            {
                count++;

                Tracer.Output(theNumber);

                if (count == 3)
                {
                    break;
                }
            }

            Tracer.Trace(TraceState.Leaving, "Program.Success2");
        }

        private static void Success1()
        {
            Tracer.Trace(TraceState.Entering, "Program.Success1");

            IEnumerable<Int32> theNumbers = EnumerableTester.GetNumbersCorrectly();

            foreach (Int32 theNumber in theNumbers)
            {
                Tracer.Output(theNumber);
            }

            Tracer.Trace(TraceState.Leaving, "Program.Success1");
        }

        private static void Fail()
        {
            Tracer.Trace(TraceState.Entering, "Program.Fail");

            IEnumerable<Int32> theNumbers = EnumerableTester.GetNumbersWrongly();

            try
            {
                foreach (Int32 theNumber in theNumbers)
                {
                    Tracer.Output(theNumber);
                }
            }
            catch (NullReferenceException ex)
            {
                Tracer.Output(ex);
            }

            Tracer.Trace(TraceState.Leaving, "Program.Fail");
        }
    }
}