﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace YieldReturnAndUsing
{
    internal sealed class WrongEnumerable : IEnumerable<Int32>
    {
        private IDisposableNumbersCollection m_Collection;

        public WrongEnumerable(IDisposableNumbersCollection collection)
        {
            Tracer.Trace(TraceState.Entering, "WrongEnumerable.ctor");
            
            m_Collection = collection;

            Tracer.Trace(TraceState.Leaving, "WrongEnumerable.ctor");
        }

        #region IEnumerable<Int32> Members

        IEnumerator<Int32> IEnumerable<Int32>.GetEnumerator()
        {
            Tracer.Trace(TraceState.Entering, "WrongEnumerable.IEnumerable<Int32>.GetEnumerator");

            ReadOnlyCollection<INumber> theList = m_Collection.TheList;

            IEnumerator<Int32> enumerator = new WrongEnumerator(theList);

            Tracer.Trace(TraceState.Leaving, "WrongEnumerable.IEnumerable<Int32>.GetEnumerator");

            return (enumerator);
        }

        #endregion

        #region IEnumerable Members

        IEnumerator IEnumerable.GetEnumerator()
        {
            Tracer.Trace(TraceState.Entering, "WrongEnumerable.IEnumerable.GetEnumerator");

            IEnumerable<Int32> enumerable = (IEnumerable<Int32>)this;

            IEnumerator<Int32> enumerator = enumerable.GetEnumerator();

            Tracer.Trace(TraceState.Leaving, "WrongEnumerable.IEnumerable.GetEnumerator");

            return (enumerator);
        }

        #endregion
    }
}